## openttd-opengfx 7.1

=== Makefile ===
#
# This file is part of the NML build framework
# NML build framework is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
# NML build framework is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with NML build framework. If not, see <http://www.gnu.org/licenses/>.
#

SHELL := /bin/bash

include Makefile.config

##################################################################
#
# Makefile.config defines these minimal definitions:
#
# PROJECT_FILENAME
# REPO_BRANCH_VERSION
#
# BASE_FILENAME
# GFX_SCRIPT_LIST_FILES
#
# LICENSE_FILE
# CHANGELOG_FILE
# README_FILE
#
#
##################################################################

# Directory structure
SCRIPT_DIR          ?= scripts

# Define the filenames of the grf and nml file. They must be in the main directoy
GRF_FILES            ?= $(addsuffix .grf,$(BASE_FILENAME))
NML_FILES            ?= $(addsuffix .nml,$(BASE_FILENAME))
DEP_FILES            ?= $(addsuffix .grf.dep,$(BASE_FILENAME)) $(addsuffix .nml.dep,$(BASE_FILENAME))
PNML_FILES           ?= $(addsuffix .pnml,$(BASE_FILENAME))
DOC_FILES            ?= $(LICENSE_FILE) $(CHANGELOG_FILE) $(README_FILE)
LNG_FILES            ?= lang/*.lng
GFX_FILES            ?=

# List of all files which will get shipped, minus documentation files.
# Documentation files often are generated from other files.
BUNDLE_FILES           ?= $(GRF_FILES) $(OBG_FILENAME)
BANANAS_INI            ?= bananas.ini

# Replacement strings in the source and in the documentation
# You may only change the values, not add new definitions
# (unless you know where to add them in other places, too)
REPLACE_TITLE       := {{REPO_TITLE}}
REPLACE_GRFID       := {{GRF_ID}}
REPLACE_FILENAME    := {{FILENAME}}

# target 'all' must be first target
all: bundle_tar

-include Makefile.in

# misc. convenience targets like 'langcheck'
-include $(SCRIPT_DIR)/Makefile_misc

# general definitions (no rules!)
-include Makefile.dist
.PHONY: all clean distclean
.PHONY: bananas gfx grf lng nml obg
.PHONY: bundle     bundle_tar bundle_bzip bundle_gzip bundle_xz   bundle_zip
.PHONY: bundle_src check      bundle_bsrc bundle_gsrc bundle_xsrc bundle_zsrc

# We want to disable the default rules. It's not c/c++ anyway
.SUFFIXES:

# Don't delete intermediate files
.PRECIOUS: %.nml %.scm %.png
.SECONDARY: %.nml %.scm %.png

FORCE:

-include $(DEP_FILES)


################################################################
#
# Program definitions / search paths
#
################################################################

# Make
MAKE           ?= make
MAKE_FLAGS     ?= -r

# Version control system
GIT                 ?= git
DEFAULT_BRANCH_NAME ?= master

# Text processing and scripting
AWK            ?= awk
GREP           ?= grep
PYTHON         ?= python

# Graphics processing
GIMP           ?= $(shell which gimp)
GIMP_FLAGS     ?= -n -i

# NML
NML            ?= nmlc
NML_FLAGS      ?= -c
ifdef REQUIRED_NML_BRANCH
	NML_BRANCH = $(shell nmlc --version | head -n1 | cut -d. -f1-2)
endif
ifdef MIN_NML_REVISION
	NML_REVISION = $(shell nmlc --version | head -n1 | cut -dr -f2 | cut -d: -f1)
endif

ifdef PNML_FILES
	CC             ?= gcc
	CC_FLAGS       ?= -C -E -nostdinc -x c-header
endif

# GRF tools
GRFID          ?= $(shell which grfid)
GRFID_FLAGS    ?= -m
MUSA           ?= musa.py
# The license is set via bananas.ini, do not supply a "custom" license.
MUSA_FLAGS     ?= -x LICENSE

# Bundle
TAR            ?= tar
TAR_FLAGS      ?= -cf
# OSX has nice extended file attributes which create their own file within tars. We don't want those, thus don't copy them
CP_FLAGS       ?= $(shell [ "$(OSTYPE)" = "Darwin" ] && echo "-rfX" || echo "-rf")

# Compression tools for bundles
ZIP            ?= zip
ZIP_FLAGS      ?= -9rq
GZIP           ?= gzip
GZIP_FLAGS     ?= -9f
BZIP           ?= bzip2
BZIP_FLAGS     ?= -9fk
XZ             ?= xz
XZ_FLAGS       ?= -efk

# Remove the @ when you want a more verbose output.
_V ?= @
_E ?= @echo


################################################################
#
# Working copy / bundle version detection.
#
################################################################

# Always run version detection, so we always have an accurate modified
# flag
REPO_VERSIONS := $(shell AWK="$(AWK)" "./findversion.sh")
REPO_MODIFIED := $(shell echo "$(REPO_VERSIONS)" | cut -f 3 -d'	')

# Use autodetected revisions
REPO_VERSION := $(shell echo "$(REPO_VERSIONS)" | cut -f 1 -d'	')
REPO_DATE := $(shell echo "$(REPO_VERSIONS)" | cut -f 2 -d'	')
REPO_HASH := $(shell echo "$(REPO_VERSIONS)" | cut -f 4 -d'	')

# Days of commit since 2000-01-01. REPO_DATE is in format YYYYMMDD.
REPO_DATE_YEAR := $(shell echo "${REPO_DATE}" | cut -b1-4)
REPO_DATE_MONTH := $(shell echo "${REPO_DATE}" | cut -b5-6 | sed s/^0//)
REPO_DATE_DAY := $(shell echo "${REPO_DATE}" | cut -b7-8 | sed s/^0//)
REPO_DAYS_SINCE_2000 := $(shell $(PYTHON) -c "from datetime import date; print( (date($(REPO_DATE_YEAR),$(REPO_DATE_MONTH),$(REPO_DATE_DAY))-date(2000,1,1)).days)")

# The version reported to OpenTTD. Usually days since 2000 + branch offset
NEWGRF_VERSION := $(shell let x="$(REPO_DAYS_SINCE_2000) + 65536 * $(REPO_BRANCH_VERSION)"; echo "$$x")

# The title consists of name and version
REPO_TITLE     := $(REPO_NAME) $(REPO_VERSION)

# Have a file which, if modified, triggers recompiling targets that use these
# variables.
Makefile.vcs: FORCE
	$(_E) "[VCS] $@"
	$(_V) echo "REPO_HASH            = $(REPO_HASH)" >> $@.new
	$(_V) echo "REPO_DATE            = $(REPO_DATE)" >> $@.new
	$(_V) echo "REPO_VERSION         = $(REPO_VERSION)" >> $@.new
	$(_V) echo "NEWGRF_VERSION       = $(NEWGRF_VERSION)" >> $@.new
	$(_V) echo "REPO_DAYS_SINCE_2000 = $(REPO_DAYS_SINCE_2000)" >> $@.new
	$(_V) cmp -s $@.new $@ || cp $@.new $@
	$(_V) -rm -f $@.new

distclean:: clean
maintainer-clean:: distclean

clean::
	$(_E) "[CLEAN DEP]"
	$(_V)-rm -rf $(DEP_FILES)

clean::
	$(_E) "[CLEAN VCS]"
	$(_V)-rm -f Makefile.vcs

################################################################
#
# Target nml
#
# Pre-processing and generation of $(NML_FILES)
#
################################################################

nml: $(NML_FILES)

%.nml: %.pnml Makefile.vcs
	$(_E) "[CPP] $@"
	$(_V) $(CC) -D NEWGRF_VERSION=$(NEWGRF_VERSION) $(CC_USER_FLAGS) $(CC_FLAGS) -MMD -MF $@.dep -MT $@ -o $@ $<

clean::
	$(_E) "[CLEAN NML]"
	$(_V)-rm -rf $(NML_FILES)


################################################################
#
# Target gfx
#
# Pre-processing and generation of png files.
# The instructions for generating png files are defined via $(GFX_SCRIPT_LIST_FILES)
#
# - $(GFX_SCRIPT_LIST_FILES) specifies a list of source xcf2png files.
# - From this file a list of rules to generate png files are created *before* processing any real targets.
# - NML generares png prerequisited for all image files.
# - The generated png files ($(GFX_FILES)) are additionally order-prerequisites to all grf files,
#   in case no NML dependencies were generated yet.
#
################################################################

ifdef GFX_SCRIPT_LIST_FILES

ifneq ($(GIMP),)

# Always include to force creation, if not existing
include Makefile.gfx

gfx: Makefile.gfx

# Generation of processing rules for png files.
# The rules are only updated, if there are any changes to them. (This is also the case for the .scm files)
#
# Make "Makefile.gfx $(GFX_FILES)" an ordering "|"-prerequisite of any target that may depend on generated png files.
#
Makefile.gfx: $(GFX_SCRIPT_LIST_FILES) Makefile Makefile.config
	$(_E) "[GFX-DEP] $@"
	$(_V) echo "" > $@
	$(_V)\
		for j in $(GFX_SCRIPT_LIST_FILES); do\
			for i in `cat $$j | grep "\([pP][cCnN][xXgG]\)" | grep -v "^#" | cut -d\  -f1 | sed "s/\.\([pP][cCnN][xXgG]\)//"`; do\
				echo "$$i.scm: $$j" >> $@;\
				echo "GFX_FILES += $$i.png" >> $@;\
				cat $(SCRIPT_DIR)/gimpscript > $$i.scm.new;\
				grep $$i.png $$j | sed -f $(SCRIPT_DIR)/gimp.sed >> $$i.scm.new;\
				echo "(gimp-quit 0)" >> $$i.scm.new;\
				cmp -s $$i.scm.new $$i.scm || cp $$i.scm.new $$i.scm;\
				rm -f $$i.scm.new;\
			done;\
		done
	$(_V) cat $(GFX_SCRIPT_LIST_FILES) | grep "\([pP][cCnN][xXgG]\)" | grep -v "^#" | sed "s/[ ] */ /g" | cut -d\  -f1-2 | sed "s/ /: /g" >> $@

# create the png file. And make sure it's re-created even when present in the repo
%.png: %.scm
	$(_E) "[GIMP] $@"
	$(_V) $(GIMP) $(GIMP_FLAGS) -b - <$< >/dev/null

clean::
	$(_E) "[CLEAN GFX]"
	$(_V) for j in $(GFX_SCRIPT_LIST_FILES); do for i in `cat $$j | grep "\([pP][cCnN][xXgG]\)" | cut -d\  -f1 | sed "s/\.\([pP][cCnN][xXgG]\)//"`; do rm -rf $$i.scm; done; done
	$(_V) rm -rf Makefile.gfx

clean-gfx::
	$(_E) "[CLEAN-GFX]"
	$(_V) for j in $(GFX_SCRIPT_LIST_FILES); do for i in `cat $$j | grep "\([pP][cCnN][xXgG]\)" | cut -d\  -f1 | sed "s/\.\([pP][cCnN][xXgG]\)//"`; do rm -rf $$i.png; done; done

else

gfx: Makefile.gfx

Makefile.gfx: FORCE
	$(_E) "[GIMP disabled]"

endif
endif


################################################################
#
# Target grf
#
# Compile grf files from nml, png and lang sources.
#
################################################################

grf: $(GFX_FILES) $(GRF_FILES)

# custom_tags.txt is used by NML to replace variables in LNG_FILES
custom_tags.txt: Makefile.vcs
	$(_E) "[NML-LNG] $@"
	$(_V) echo "VERSION        :$(REPO_VERSION)" > $@
	$(_V) echo "VERSION_STRING :$(REPO_VERSION)" >> $@
	$(_V) echo "TITLE          :$(REPO_TITLE)" >> $@
	$(_V) echo "FILENAME       :$(GRF_FILES)" >> $@
	$(_V) echo "REPO_DATE      :$(REPO_DATE)" >> $@
	$(_V) echo "REPO_HASH      :$(REPO_HASH)" >> $@
	$(_V) echo "NEWGRF_VERSION :$(NEWGRF_VERSION)" >> $@
	$(_V) echo "DAYS_SINCE_2K  :$(REPO_DAYS_SINCE_2000)" >> $@

%.grf: %.nml $(LNG_FILES) custom_tags.txt | Makefile.gfx $(GFX_FILES)
	$(_E) "[NML] $@"
ifeq ($(NML),)
	$(_E) "No NML compiler found!"
	$(_V) false
endif
ifdef REQUIRED_NML_BRANCH
ifneq ($(REQUIRED_NML_BRANCH),$(NML_BRANCH))
	$(_E) "Wrong NML version. This NewGRF requires an NML from the $(REQUIRED_NML_BRANCH) branch, but $(NML_BRANCH) found."
	$(_V) false
endif
endif
ifdef MIN_NML_REVISION
ifeq ($(shell [ "$(NML_REVISION)" -lt "$(MIN_NML_REVISION)" ] && echo "true" || echo "false"),true)
	$(_E) "Too old NML revision. At least r$(MIN_NML_REVISION) is required, but r$(NML_REVISION) found."
	$(_V) false
endif
endif
	$(_V) $(NML) $(NML_FLAGS) -M --MF=$@.dep --grf $@ $<

clean::
	$(_E) "[CLEAN GRF]"
	$(_V)-rm -rf $(GRF_FILES)
	$(_V)-rm -rf $(GRF_FILES).cache
	$(_V)-rm -rf $(GRF_FILES).cacheindex
	$(_V)-rm -rf .nmlcache
	$(_V)-rm -rf custom_tags.txt

maintainer-clean::
	$(_E) "[MAINTAINER-CLEAN GRF]"
	$(_V) -rm -rf $(MD5_SRC_FILENAME)


################################################################
#
# Target obg
#
# Create the baseset meta data file.
#
################################################################

ifdef OBG_FILENAME

obg: $(OBG_FILENAME)

%.obg: $(GFX_FILES) $(GRF_FILES) $(LNG_FILES) Makefile.vcs
ifeq ($(GRFID),)
	$(_E) "Cannot create obg files without grfid. Please install grfcodec, and try again. Aborting."
	$(_V) false
endif

	$(_E) "[ASSEMBLING] $@"
	@echo "[metadata]" > $@
	@echo "name        = $(REPO_NAME)" >> $@
	@echo "shortname   = $(REPO_SHORTNAME)" >> $@
	@echo "version     = $(NEWGRF_VERSION)" >> $@
	@echo "palette     = $(REPO_PALETTE)" >> $@
	@echo "blitter     = $(REPO_BLITTER)" >> $@
	$(_V) $(SCRIPT_DIR)/translations.sh | sed 's/{TITLE}/$(REPO_TITLE)/' >> $@

	@echo "" >> $@
	@echo "[files]" >> $@
	$(_V) $(_V)for i in $(BASE_FILENAME); do echo "`echo $$i | cut -d_ -f2` = $$i.grf" >> $@; done

	@echo "" >> $@
	@echo "[md5s]" >> $@
	$(_V)for i in $(GRF_FILES); do printf "%-18s = %s\n" $$i `$(GRFID) $(GRFID_FLAGS) $$i` >> $@; done

=== debian/changelog ===
openttd-opengfx (7.1-1) unstable; urgency=medium

  * [a27034b] Update watch file
  * [d2bc84d] Bump standards version to 4.6.0 (no changes required)
  * [4b07af7] Add upstream metadata
  * [3a4714f] New upstream release 7.1
  * [32090a7] Revert "Add patch to fix documentation filenames"
  * [a5618ad] Remove broken-symlink lintian override

 -- Matthijs Kooijman <matthijs@stdin.nl>  Tue, 23 Nov 2021 14:00:03 +0100

=== debian/control ===
Source: openttd-opengfx
Section: games
Priority: optional
Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
Uploaders: Jordi Mallach <jordi@debian.org>
Build-Depends: debhelper-compat (= 13), nml (>= 0.3.0), gimp, grfcodec, python3
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/openttd-team/openttd-opengfx
Vcs-Git: https://salsa.debian.org/openttd-team/openttd-opengfx.git
Homepage: https://github.com/OpenTTD/OpenGFX
Rules-Requires-Root: no

Package: openttd-opengfx
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: free graphics set for use with the OpenTTD game
 OpenGFX is a graphics set for the OpenTTD game that has been built from
 scratch under an open license. It allows the OpenTTD game to be played without
 needing the graphics files from the original Transport Tycoon Deluxe game.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Make sure that gimp doesn't read or write data into $HOME/.gimp-2.6 or
# elsewhere
export GIMP2_DIRECTORY=$(CURDIR)/build-data/gimp-data
export GIMP3_DIRECTORY=$(CURDIR)/build-data/gimp-data
export XDG_DATA_HOME=$(CURDIR)/build-data/share
export XDG_CACHE_HOME=$(CURDIR)/build-data/cache
export XDG_CONFIG_HOME=$(CURDIR)/build-data/config

%:
	dh $@

INSTALL_ROOT=debian/openttd-opengfx
DATA_DIR=usr/share/games/openttd/baseset/opengfx
DOC_DIR=/usr/share/doc/openttd-opengfx


OPTIONS=
OPTIONS += "INSTALL_DIR=$(INSTALL_ROOT)/$(DATA_DIR)"
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
# By default, _V is set to @ to suppress commands, clear it to *show*
# commands.
OPTIONS += "_V="
endif
OPTIONS += "PYTHON=python3"

override_dh_auto_build:
	# Remove all graphics files that can be rebuilt (from gimp xcf
	# files).
	make clean-gfx $(OPTIONS)
	# Then rebuild everything
	make grf $(OPTIONS)
	# This checks whether the checksums of the resulting grf files
	# match the official build. They should usually match, but it is
	# ok if not (e.g.  for different nml versions), so just show the
	# results but do not error out on a mismatch.
	make check $(OPTIONS) || true

override_dh_auto_install:
	make install $(OPTIONS)
	# Verify that the license.txt that was installed is equal to the
	# GPL-2 common license and then just link to that one instead
	diff -q /usr/share/common-licenses/GPL-2 $(INSTALL_ROOT)/$(DATA_DIR)/license.txt
	dh_link usr/share/common-licenses/GPL-2 $(DATA_DIR)/license.txt

override_dh_installdocs:
	dh_installdocs README.md
	# Save space by linking identical files, but check equality first
	diff -q $(INSTALL_ROOT)/$(DOC_DIR)/README.md $(INSTALL_ROOT)/$(DATA_DIR)/readme.txt
	dh_link $(DOC_DIR)/README.md $(DATA_DIR)/readme.txt

override_dh_installchangelogs:
	dh_installchangelogs changelog.txt
	# Save space by linking identical files, but check equality first
	diff -q $(INSTALL_ROOT)/$(DOC_DIR)/changelog $(INSTALL_ROOT)/$(DATA_DIR)/changelog.txt
	dh_link $(DOC_DIR)/changelog $(DATA_DIR)/changelog.txt

override_dh_auto_test:
	# This defaults to running make check, which is not a test
	# suite, so override to do nothing.

override_dh_auto_clean:
	make distclean $(OPTIONS)
	# Remove any data created by gimp
	rm -rf "$(GIMP2_DIRECTORY)"

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/opengfx-(\d\S+)-source\.(.*)/openttd-opengfx-$1\.$2/ \
  https://www.openttd.org/downloads/opengfx-releases/latest .*/opengfx-(\d\S+)-source\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
